(*
 * Dynamic web page generation with Standard ML
 * Copyright (C) 2003  Adam Chlipala
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

(* CGI interaction *)

signature WEB =
sig
    val for : (int -> unit) -> int * int -> unit

    val print : string -> unit
    val output : unit -> unit

    val setParam : string * string list -> unit
    val setSingleParam : string * string -> unit
    val getParam : string -> string
    val getMultiParam : string -> string list

    val pushParams : (string * string list) list -> unit
    val popParams : unit -> unit
    val withParams : (unit -> 'a) -> (string * string list) list -> 'a

    val getCgi : string -> string option

    val html : string -> string
    val htmlNl : string -> string

    exception Format of string
    val stoi : string -> int
    val stor : string -> real

    val summary : unit -> string
end